/****************************************************************************
    
    This file is part of The Newtonator soft synth.

    Copyright (C) 2010-2011 Michael Bechard <mbechard@users.sourceforge.net>

    The Newtonator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    The Newtonator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with The Newtonator.  If not, see <http://www.gnu.org/licenses/>.

****************************************************************************/

#ifndef APPLEWIDGET_H
#define APPLEWIDGET_H

//#include <gtkmm.h>
#include <gtkmm/drawingarea.h>

class NewtScalarWidget;

class AppleWidget : public Gtk::DrawingArea
{
    public:
        AppleWidget(NewtScalarWidget& parent);
        virtual ~AppleWidget();

        //Event Handlers
        void on_spin_value_changed();

        static const double m_defaultWidth;
        static const double m_defaultHeight;

    protected:
        Cairo::RefPtr<Cairo::Context> InitNewContext();
        int GetWidgetY(int y, int height);
        int GetWidgetX(int x, int width);
        void MousePosChangeAbs(double x, double y);

        //Overrides:
        virtual void on_size_request(Gtk::Requisition* requisition);
        virtual void on_size_allocate(Gtk::Allocation& allocation);
        virtual bool on_expose_event(GdkEventExpose* event);
        virtual void on_map();
        virtual void on_unmap();
        virtual bool on_button_press_event(GdkEventButton* event);
        virtual bool on_button_release_event(GdkEventButton* event);
        virtual bool on_motion_notify_event(GdkEventMotion* event);

    private:
        void DrawMe(Cairo::RefPtr<Cairo::Context> context);

        //Cairo::RefPtr<Cairo::Context> m_context;
        NewtScalarWidget& m_parent;
        double m_width;
        double m_height;
        double m_x;
        double m_y;
        double m_clickX;
        double m_clickY;
        double m_yBoundUpper;
        double m_yBoundLower;
        double m_screenHeight;
        double m_initVal;
};

#endif // APPLEWIDGET_H
